
var dsDapAnDung = [];
$(document).ready(function () {
    for (var i = 0; i < arr_DapAn.length; i++) {
        khaibaodapandung(arr_DapAn[i].ID, arr_DapAn[i].ArrPos);
    }
});

function khaibaodapandung(idQ, vitri_dapandung) {
    dsDapAnDung.push(new Array(idQ, vitri_dapandung));
}

function Question(id, text, type, answers, correctAnswer, isRight) {
    this.Id = id;
    this.Text = text;
    this.Type = type;
    this.Answers = answers;
    this.CorrectAnswer = correctAnswer;
    this.IsRight = isRight;
}

function Test(questions) {
    this.Questions = questions;
}
Test.prototype.AddQuestion = function (question) {
    this.Questions[this.Questions.length] = question;
}
var lstCauTraLoi = new Test(new Array()); /*Trac Nghiem*/

//Hàm thông báo đúng sai khi trả lời câu hỏi
function Alert_Ques(boolNext, id) {
    if (boolNext) //câu trả lời đúng
    {
        swal({
            type: 'success',
            title: 'Trả lời đúng',
            confirmButtonText: 'Tiếp tục',
            confirmButtonColor: '#28a745',
            target: document.getElementById(id),
            allowOutsideClick: false,
        }).then((result) => { //Chuyển slide
            if (result.value) {
                QuestionNextSlide();
            }
        }); //end then
    }
    else {
        swal({
            type: 'error',
            title: 'Trả lời sai',
            showCancelButton: true,
            confirmButtonText: 'Tiếp tục',
            confirmButtonColor: '#ffc107',
            cancelButtonText: "Làm lại",
            cancelButtonColor: '#17a2b8',
            reverseButtons: true,
            target: document.getElementById(id),
            allowOutsideClick: false,
        }).then((result) => { //Chuyển slide
            if (result.value) {
                QuestionNextSlide();
            }
        }); //end then
    }
}

// Chuyen slide ke tiep
function QuestionNextSlide() {
    var totalEle = $('div[class*="box_sd"]').length; //Tổng số slide duyệt theo class box_sd
    // index của slide được chọn
    var index = $("ul#listSlide > li.action").index();
    if ((index + 1) == totalEle) //Hết slide
    {
        //console.log('het slide');
        return;
    }
    else {
        //console.log('còn slide');
        $("li").eq(index + 1).click(); //Chuyển tới slide kế tiếp	
    }
}

/*Show Slide dung - sai*/
function ShowSubQuizSlide(boolNext, ch_name) {
    $(".box_slider .box_sd").removeClass("action");
    if (boolNext) {
        for (k = 0; k < list_slider.length; k++) {
            if (list_slider[k].subquiz_right == ch_name) {
                var index = $("." + list_slider[k].name).index();
                loadcontentslider(index, list_slider[k].name);
                $("." + list_slider[k].name).addClass("action");
                break;
            }
        }
    }
    else {
        for (k = 0; k < list_slider.length; k++) {
            if (list_slider[k].subquiz_wrong == ch_name) {
                var index = $("." + list_slider[k].name).index();
                loadcontentslider(index, list_slider[k].name);
                $("." + list_slider[k].name).addClass("action");
                break;
            }
        }
    }

    GetMaxTime(index);
    stopAllMedia();

    start_slider();
    if (is_play)
        button = '<i class="fa">&#xf04c;</i>';
    else
        button = '<i class="fa">&#xf04b;</i>';
    $(".play").html(button);
    isQuestionSlide = true;

    load_trigger();
    Create_trigger_video();
    reload_checkbox_toggle();
}

/*Trac Nghiem*/
function TN_TiepTuc(objT) {
    var id = objT.parentNode.id;		// Lấy id của div parent
    var obj = $(document.getElementById(id));

    var boolNext = true;
    var idParent = $(obj).attr('id');
    var id_noidungcauhoi = $(obj).data('id_noidung_cauhoi');
    var arr = new Array() //Array chứa (1)id, (2)nội dung câu hỏi, (3)loại câu hỏi, (4)đáp án trả lời, (5)đáp án đúng, (6)true or false (trả lời đúng hay sai). - model Question
    arr.push($(obj).data('id_noidung_cauhoi')); //id
    arr.push($(document.getElementById(id_noidungcauhoi)).text().trim()) //cau hoi
    arr.push($(obj).data('type')) //type

    var index_cauhoi = 0;
    var id_dapandung = 0;
    var dapan_dung = "";
    for (var p = 0; p < dsDapAnDung.length; p++) {
        if (dsDapAnDung[p][0] == id_noidungcauhoi) {
            index_cauhoi = p;
        }
    }
    var dapAn = "";
    id_dapandung = dsDapAnDung[index_cauhoi][1];
    $('.TN_Check').each(function () {
        var val_par = $(this).attr("data-idparent");
        var val_iddapan = $(this).data("iddapan");
        if (idParent == val_par) //xet trong Id hien tai
        {
            var achar = val_iddapan.split("_");
            var aint = achar[1].charCodeAt(0) - 96;

            if ((this).checked) {
                if (!id_dapandung.includes(aint))
                    boolNext = false;
                dapAn += $(document.getElementById(val_iddapan)).text().trim() + '\r\n';
            }
            else
                if (!(this).checked && id_dapandung.includes(aint))
                    boolNext = false;

            if (id_dapandung.includes(aint)) {
                dapan_dung += $(document.getElementById(val_iddapan)).text().trim() + '\r\n';
            }
        }
    });
    arr.push(dapAn);
    arr.push(dapan_dung); //dap an dung
    arr.push(boolNext); //isRight	
    lstCauTraLoi.AddQuestion(arr);

    //Alert_Ques(boolNext, id); //Kiểm tra đúng sai khi trả lời câu hỏi
    ShowSubQuizSlide(boolNext, actived_slide_name);
}

/*Tro lai Slide TN*/
function BackToQuizSlide() {
    $(".box_slider .box_sd").removeClass("action");
    var index = $("." + actived_slide_name).index();
    loadcontentslider(index, actived_slide_name);
    $("." + actived_slide_name).addClass("action");
}

/*Dung Sai*/
function DS_TiepTuc(objT) {
    var id = objT.parentNode.id;		// Lấy id của div parent
    var obj = $(document.getElementById(id));

    var boolNext = true;
    var idParent = $(obj).attr('id');
    var id_noidungcauhoi = $(obj).data('id_noidung_cauhoi');
    var arr = new Array() //Array chứa (1)id, (2)nội dung câu hỏi, (3)loại câu hỏi, (4)đáp án trả lời, (5)đáp án đúng, (6)true or false (trả lời đúng hay sai).- model Question
    arr.push($(obj).data('id_noidung_cauhoi')); //id
    arr.push($(document.getElementById(id_noidungcauhoi)).text().trim()) //cau hoi
    arr.push($(obj).data('type')) //type
    var i = 1;
    var index_cauhoi = 0;
    var arr_idda = [];
    var dapan_dung = "";
    for (var p = 0; p < dsDapAnDung.length; p++) {
        if (dsDapAnDung[p][0] == id_noidungcauhoi) {
            index_cauhoi = p;
        }
    }
    arr_idda = dsDapAnDung[index_cauhoi][1];
    var dapAn = "";
    $('.DS_Check').each(function () {
        var val_par = $(this).attr("data-idparent");
        if (idParent == val_par) //xet trong Id hien tai
        {
            if ((this).checked) {
                if (arr_idda.includes(i)) { } else boolNext = false;
                dapAn += $(document.getElementById($(this).data("iddapan"))).text().trim() + '\r\n ';
            } else if (!(this).checked && arr_idda.includes(i)) boolNext = false;
            if (arr_idda.includes(i)) {
                dapan_dung += $(document.getElementById($(this).data("iddapan"))).text().trim() + '\r\n ';
            }
            i++;
        }
    });
    arr.push(dapAn);
    arr.push(dapan_dung); //dap an dung
    arr.push(boolNext); //isRight
    lstCauTraLoi.AddQuestion(arr);

    //Alert_Ques(boolNext, id); //Kiểm tra đúng sai khi trả lời câu hỏi
    ShowSubQuizSlide(boolNext, actived_slide_name);
}

/*Dien khuyet*/
function DK_TiepTuc(objT) {
    var id = objT.parentNode.id;		// Lấy id của div parent
    var obj = $(document.getElementById(id));

    var boolNext = true;
    var idParent = $(obj).attr('id');
    var id_noidungcauhoi = $(obj).data('id_noidung_cauhoi');
    var arr = new Array() //Array chứa (1)id, (2)nội dung câu hỏi, (3)loại câu hỏi, (4)đáp án trả lời, (5)đáp án đúng, (6)true or false (trả lời đúng hay sai).- model Question
    arr.push($(obj).data('id_noidung_cauhoi')); //id
    arr.push($(document.getElementById(id_noidungcauhoi)).text().trim()) //cau hoi
    arr.push($(obj).data('type')) //type
    var i = 0;
    var index_cauhoi = 0;
    var arr_idda = [];
    var dapan_dung = "";
    var dapAn = "";
    for (var p = 0; p < dsDapAnDung.length; p++) {
        if (dsDapAnDung[p][0] == id_noidungcauhoi) {
            index_cauhoi = p;
        }
    }
    arr_idda = dsDapAnDung[index_cauhoi][1];
    $('.DK_Combox').each(function () {
        var val_par = $(this).attr("data-idparent");
        if (val_par == idParent) { // xet trong cau hien tai			
            var textOption = (this).options[(this).selectedIndex].text;
            if (arr_idda[i] == (this).selectedIndex) { } else boolNext = false;
            if ((this).selectedIndex != 0) dapAn += "(" + i + "): " + textOption.trim() + ' ; \r\n ';
            dapan_dung += "(" + i + "): " + (this).options[arr_idda[i]].text.trim() + ' ; \r\n ';
            i++;
        }
    });
    arr.push(dapAn);
    arr.push(dapan_dung); //dap an dung
    arr.push(boolNext); //isRight
    lstCauTraLoi.AddQuestion(arr);

    //Alert_Ques(boolNext, id); //Kiểm tra đúng sai khi trả lời câu hỏi    
    ShowSubQuizSlide(boolNext, actived_slide_name);
}

/*Gach chan*/
function GC_TiepTuc(objT) {
    var id = objT.parentNode.id;		// Lấy id của div parent
    var obj = $(document.getElementById(id));

    var boolNext = true;
    var idParent = $(obj).attr('id');
    var id_noidungcauhoi = $(obj).data('id_noidung_cauhoi');
    var arr = new Array();//Array chứa (1)id, (2)nội dung câu hỏi, (3)loại câu hỏi, (4)đáp án trả lời, (5)đáp án đúng, (6)true or false (trả lời đúng hay sai).- model Question
    arr.push($(obj).data('id_noidung_cauhoi')); //id
    arr.push($(document.getElementById(id_noidungcauhoi)).text().trim()) //cau hoi
    arr.push($(obj).data('type')) //type
    var i = 1;
    var index_cauhoi = 0;
    var arr_idda = [];
    var dapan_dung = "";
    for (var p = 0; p < dsDapAnDung.length; p++) {
        if (dsDapAnDung[p][0] == id_noidungcauhoi) {
            index_cauhoi = p;
        }
    }
    arr_idda = dsDapAnDung[index_cauhoi][1];
    var dapAn = "";
    $('.GC_Check').each(function () {
        var val_par = $(this).attr("data-idparent");
        if (idParent == val_par) //xet trong Id hien tai
        {
            if ((this).checked) {
                if (arr_idda.includes(i)) { } else boolNext = false;
                dapAn += $(document.getElementById($(this).data("iddapan"))).text().trim() + '\r\n';
            } else if (!(this).checked && arr_idda.includes(i)) boolNext = false;
            if (arr_idda.includes(i)) {
                dapan_dung += $(document.getElementById($(this).data("iddapan"))).text().trim() + '\r\n';
            }
            i++;
        }
    });
    arr.push(dapAn);
    arr.push(dapan_dung); //dap an dung
    arr.push(boolNext); //isRight
    lstCauTraLoi.AddQuestion(arr);

    //Alert_Ques(boolNext, id); //Kiểm tra đúng sai khi trả lời câu hỏi
    ShowSubQuizSlide(boolNext, actived_slide_name);
}

/*Noi cheo*/
function NC_TiepTuc(objT) {
    var id = objT.parentNode.id;		// Lấy id của div parent
    var obj = $(document.getElementById(id));

    var boolNext = true;
    var idParent = $(obj).attr('id');
    var id_noidungcauhoi = $(obj).data('id_noidung_cauhoi');
    var arr = new Array() //Array chứa (1)id, (2)nội dung câu hỏi, (3)loại câu hỏi, (4)đáp án trả lời, (5)đáp án đúng, (6)true or false (trả lời đúng hay sai).- model Question
    arr.push($(obj).data('id_noidung_cauhoi')); //id
    arr.push($(document.getElementById(id_noidungcauhoi)).text().trim()) //cau hoi
    arr.push($(obj).data('type')) //type
    var i = 0;
    var arr_idda = [];
    var dapan_dung = "";
    var dapAn = "";
    for (var p = 0; p < dsDapAnDung.length; p++) {
        if (dsDapAnDung[p][0] == id_noidungcauhoi) {
            arr_idda = dsDapAnDung[p][1];
        }
    }
    $(".NC_Combox").each(function () {
        var val_par = $(this).attr("data-idCauHoi"); //xét trong idparent hiện tại	
        if (val_par == idParent) { //	
            var textOption = (this).options[(this).selectedIndex].text;
            if (arr_idda[i] == (this).selectedIndex) { } else boolNext = false;
            if ((this).selectedIndex != 0) dapAn += "(" + i + "): " + textOption.trim() + " - " + (this).options[(this).selectedIndex].value + ' ; \r\n ';
            dapan_dung += "(" + i + "): " + (this).options[arr_idda[i]].text.trim() + " - " + (this).options[(this).selectedIndex].value + ' ; \r\n ';
            i++;
        }
    });
    arr.push(dapAn);
    arr.push(dapan_dung); //dap an dung
    arr.push(boolNext); //isRight
    lstCauTraLoi.AddQuestion(arr);

    //Alert_Ques(boolNext, id); //Kiểm tra đúng sai khi trả lời câu hỏi
    ShowSubQuizSlide(boolNext, actived_slide_name);
}

/*O chu*/
function OC_TiepTuc(objT) {
    var id = objT.parentNode.id;		// Lấy id của div parent
    var obj = $(document.getElementById(id));

    var res = id.substr(id.length - 1);
    var obj = $(document.getElementById('check_bitech_puzzle_' + res));
    obj.click();

    Alert_Ques(boolNext, id); //Kiểm tra đúng sai khi trả lời câu hỏi
}

//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
//Nop Bai submit

function NopBai_Submit() {
    // var object = $(document.getElementById('SlEnd'));
    var nextQues = $(document.getElementById('score_questions'));
    var correctCount = 0;
    var totalQuestions = lstCauTraLoi.Questions.length;
    var resultsSummary = "";
    // object.prop('hidden', true);
    nextQues.hidden = false;
    for (var i = 0; i < lstCauTraLoi.Questions.length; i++) {
        var question = lstCauTraLoi.Questions[i];
        var wasCorrect = false;
        if (lstCauTraLoi.Questions[i][5]) wasCorrect = true;
        else wasCorrect = false;
        if (wasCorrect) {
            correctCount++;
        }
        if (parent.RecordQuestion) {
            parent.RecordQuestion(lstCauTraLoi.Questions[i][0], lstCauTraLoi.Questions[i][1], lstCauTraLoi.Questions[i][2], lstCauTraLoi.Questions[i][3], lstCauTraLoi.Questions[i][4], lstCauTraLoi.Questions[i][5]);
        }
        console.log(parent.RecordQuestion);
        resultsSummary += "<div class='questionResult'><h3>Câu hỏi " + (i + 1) + "</h3>";
        if (wasCorrect) {
            resultsSummary += "<em><font color='green'>Đúng</font></em><br>"
        } else {
            resultsSummary += "<em><font color='red'>Sai</font></em><br>"
            resultsSummary += "Đáp án của bạn: " + lstCauTraLoi.Questions[i][3] + "<br>"
            resultsSummary += "Đáp án đúng: " + lstCauTraLoi.Questions[i][4] + "<br>"
        }
        resultsSummary += "</div>";
    }
    console.log('------------------+');
    var score = Math.round(correctCount * 100 / totalQuestions);
    resultsSummary = "<h3>Điểm: " + score + "</h3>" + resultsSummary;
    document.getElementById("tk_cauhoi").innerHTML = resultsSummary;
    if (parent.RecordTest) {
        parent.RecordTest(score);
    }
}

function Chekc_Ans(type, objCauhoi) {
    switch (type) {
        case 'TN':
            TN_TiepTuc(objCauhoi);
            break;
        case 'DS':
            DS_TiepTuc(objCauhoi);
            break;
        case 'DK':
            DK_TiepTuc(objCauhoi);
            break;
        case 'GC':
            GC_TiepTuc(objCauhoi);
            break;
        case 'NC':
            NC_TiepTuc(objCauhoi);
            break;
        case 'OC':
            var indSlide = $(objCauhoi).data('id');
            var res = indSlide.substr(indSlide.length - 1);
            var obj = $(document.getElementById('check_bitech_puzzle_' + res));
            obj.click();
            break;
    }
}

function ChooseSlide(lstSlideName, isCheck) {
    lstCauTraLoi = new Test(new Array());
    if (isCheck) { //duyet qua tat ca slide
        for (var i = 0; i < lstSlideName.length; i++) {
            var object = $(document.getElementById(lstSlideName[i]));
            var type = $(object).data("type");
            Chekc_Ans(type, $(object));
        }
    }
    else //duyet qua cac slide da dien dap an
        if (lstSlideName.length > 1) {
            for (var i = 0; i < lstSlideName.length - 1; i++) {
                var object = $(document.getElementById(lstSlideName[i]));
                var type = $(object).data("type");
                Chekc_Ans(type, $(object));
            }
        }
}

function Submit_DapAn() {
    lstCauTraLoi = new Test(new Array());
    $('.bitech_question').each(function (i, obj) {
        var type = $(this).attr('data-type');
        Chekc_Ans(type, this);
    });
    NopBai_Submit();

    $(".List_slider ul li").removeClass("action");
    $(this).addClass("action");
    $(".box_slider .box_sd").removeClass("action");

    $(".check_score").addClass("action");
    //$(".List_slider").setAttribute("hidden", true);
    document.getElementsByClassName('List_slider')[0].style.visibility = 'hidden';
}

function LamLai() {
    document.getElementsByClassName('List_slider')[0].style.visibility = 'visible';
    $(".check_score").removeClass("action");
    $("#box_slider_1").addClass('action'); // set lai slide dau tien 
}

function NumberDungSai() {
    var numDung = 0;
    var numSai = 0;
    $('.box_sd').each(function () {
        var val_par = $(this).data("isright");
        if (val_par) numDung++;
        else numSai++;
    });
    document.getElementById("SoCauDung").innerHTML = "Số câu đúng : " + numDung;
    document.getElementById("SoCauSai").innerHTML = "Số câu sai: " + numSai;
}

//------------------------------

function OnTKClick() {
    console.log(lstCauTraLoi.Questions);
}

function ShowDKTooltip(x) {
    var tt = document.getElementById("tt" + x.id);
    if (tt && x.selectedIndex > 0) {
        tt.innerHTML = x.options[x.selectedIndex].text;
        tt.classList.add("tooltip_show");
    }
}

function HideDKTooltip(x) {
    var tt = document.getElementById("tt" + x.id);
    if (tt) {
        tt.innerHTML = "";
        tt.classList.remove("tooltip_show");
    }
}