﻿function initPlayer(id, idplayer, idplay, idtime) {
    var audio_player = $('#' + idplayer);
    var play_button = $('#' + idplay);
    var time = $('#' + idtime);
    var player = document.getElementById(id);
    var duration = 0;
    var volume = 1;

    player.onloadedmetadata = function () {
        duration = player.duration;
    };

    player.load();
    player.volume = 1;

    player.addEventListener("timeupdate", function () {
        time.text(getTime(player.currentTime));
    }, false);

    play_button.click(function () {
        player[player.paused ? 'play' : 'pause']();
        $(this).toggleClass("fa-pause", !player.paused);
        $(this).toggleClass("fa-play", player.paused);
    });
}

function getTime(t) {
    var m = ~~(t / 60), s = ~~(t % 60);
    return (m < 10 ? "0" + m : m) + ':' + (s < 10 ? "0" + s : s);
}